<?php

define("APP_ID", '138377122886126');
define("API_SECRET", '4e9d49f390b063700817e9209fb80e99');
define("SCOPE","publish_stream,read_stream,user_events,user_hometown,friends_hometown,user_location,friends_location");
define("REDIRECT_URL",'http://localhost/principal.php');





class SocialSight{

	private $LOGIN_URL;
	private $INSTANCE;
	private static $instaciaSingletonSS;
	private $access_token;


	function __construct(){
		$this->LOGIN_URL="https://www.facebook.com/dialog/oauth?client_id=".APP_ID."&redirect_uri=".REDIRECT_URL."&scope=".SCOPE;
		$this->INSTANCE = new Facebook(array('appId'  => APP_ID,'secret' => API_SECRET,'cookie' => true, ));
		$this->access_token=null;
	}

	public static function getInstanciaSingleton(){
		if (  !self::$instaciaSingletonSS instanceof self){
			self::$instaciaSingletonSS = new self;
		}
		return self::$instaciaSingletonSS;
	}

	public function getExitUrl(){
		$tmp=urldecode(SocialSight::getInstanciaSingleton()->INSTANCE->getLogoutUrl(array('next' => 'http://localhost/socialsight/salir.php')));
		return $tmp;
	}

	public function getSession(){
		return SocialSight::getInstanciaSingleton()->INSTANCE->getSession();
	}

	public function getInstancia(){
		return SocialSight::getInstanciaSingleton()->INSTANCE;
	}

	public function getLoginUrl(){
		return SocialSight::getInstanciaSingleton()->LOGIN_URL;
	}

	public function getAccessToken(){
		$session=SocialSight::getInstanciaSingleton()->getSession();

		if($session){
			return $session['access_token'];
		}
		else{
			return null;
		}
	}
}







//FUNCIONES VISUALES
function MostrarMenu(){

	$socialsight=SocialSight::getInstanciaSingleton();
	$facebook=$socialsight->getInstancia();
	$url=$socialsight->getExitUrl();
	$session = $socialsight->getSession();



	if(!$session)
		$url="/socialsight/salir.php";




	echo "<div>
			<ul><img src=\"/socialsight/mini_logo_socialsight.png\" alt=\"Mini Logotipo estatico de SocialSight, gato con bigotes\" ALIGN=RIGHT></ul>

			<ul>
				<li><a accesskey=\"I\" title=\"Pagina de inicio del usuario\" href=\"/socialsight/index.php\" hreflang=\"es\" shape=\"rect\">Inicio</a></li>
				<li><a accesskey=\"P\" title=\"Pagina de perfil del usuario\" href=\"/socialsight/perfil.php\" hreflang=\"es\" shape=\"rect\">Perfil</a></li>
				<li><a accesskey=\"A\" title=\"Pagina de amigos del usuario\" href=\"/socialsight/amigos.php?paginaDeAmigos=1\" hreflang=\"es\" shape=\"rect\">Amigos</a></li>
				<li><a accesskey=\"S\" title=\"Salir de SocialSight\" href=\"" .$url. "\" hreflang=\"es\" shape=\"rect\">Salir</a></li>
			</ul>
		</div>";
}

function paginadorAmigos($numPaginas){
	$cadena="Pagina ";
	for ( $i = 1 ; $i <= $numPaginas ; $i ++) {
		$cadena=$cadena. "<a href=\"/socialsight/amigos.php?paginaDeAmigos=".$i."\" shape=\"rect\">".$i."   </a>";
	}
	return $cadena;
}

function HTML(){
	//return "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\"> <HTML lang=\"es\">";
	return "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">
	<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"es\">";
}

function ImportarCSS(){
	echo "<link href=\"/socialsight/ssmain.css\" rel=\"stylesheet\" type=\"text/css\" media=\"screen\" />";
}

function MostrarCabecera($titulo){

	echo"<HEAD>";
	echo '<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>';
	echo "<TITLE>".$titulo."</TITLE>";
	ImportarCSS();
	echo"</HEAD>";
}


function MostrarInputForm($pagina,$id){

	echo "<form name=\"mensaje_publicar_en_muro\" class=\"mensaje_publicar_en_muro\" action="."\"$pagina".".php?id=".$id."\" method=\"post\">";
	echo "<textarea cols=\"50\" rows=\"4\" name=\"contenido_mensaje_deseado_poner_muro\" tabindex=\"1\"></textarea>";
	echo "<input type=\"submit\" name=\"boton_publicar_muro\" value=\"Publicar mensaje\" tabindex=\"2\">";
	echo "</form>";

}

//FUNCIONES MURO
function PublicarMuro($FacebookInstance, $TokenAcceso, $Mensaje, $quien){



	if($quien=="me"){
		$w='/me/feed';
	}
	else{
		$w='/'.$quien.'/feed';
	}


	$attachment =  array(
	'access_token' => $TokenAcceso,
	'message' => $Mensaje,
	'name' => "",
	'description' => ""
	);


	try{
		$FacebookInstance->api($w, 'POST', $attachment);
		return 0;
	}

	catch (FacebookApiException $e) {

		echo "Se ha producido un error, puede que se cerrase la sesion. Por favor salga y vuelva a conectarse de nuevo.";
		return -1;
	}
}


function ResponderMensaje($FacebookInstance,$id, $mensaje){

	$cadena="/".$id."/comments";

	try{
		$FacebookInstance->api($cadena,"POST",array("message"=>$mensaje));
		return 0;
	}
	catch (FacebookApiException $e) {
		echo "Se ha producido un error, puede que se cerrase la sesion. Por favor salga y vuelva a conectarse de nuevo.";
		return -1;
	}

}


//FUNCIONES OBTENCION DE DATOS

function getCompleteUser($FacebookInstance,$id){
	$datos=$FacebookInstance->api('/'.$id);
	return $datos;
}

function getUserFQL($FacebookInstance,$id){
	try{
		$query="select name from user where uid='".$id."'";
		$respuesta = $FacebookInstance->api(array('method' => 'fql.query','query' =>$query,));
	}
	catch (FacebookApiException $e) {

		echo "Se ha producido un error, puede que se cerrase la sesion. Por favor salga y vuelva a conectarse de nuevo.";
	}

	return $respuesta;
}

function getStreamFQL($FacebookInstance,$id){
	try{
		$query="select source_id ,created_time,message,likes from stream where post_id='".$id."'";
		$respuesta = $FacebookInstance->api(array('method' => 'fql.query','query' =>$query,));
	}

	catch (FacebookApiException $e) {

		echo "Se ha producido un error, puede que se cerrase la sesion. Por favor salga y vuelva a conectarse de nuevo.";
	}

	return $respuesta;
}

function getEvents($FacebookInstance,$id){

	if($id=="me"){
		$events= $FacebookInstance->api('/me/events');
		return $events;
	}
	else{

	}
}

function getMeId($FacebookInstance){
	return $FacebookInstance->getUser();
}

function getMe($FacebookInstance){

	$datos=$FacebookInstance->api('/me/');
	return $datos;
}

function getUser($access_token, $id){

	$url = 'https://graph.facebook.com/'.$id.'?access_token=' . $access_token;
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	$response = curl_exec($ch);
	curl_close($ch);

	//echo $response;

	$user = json_decode($response);

	return $user;
}

function ObtenerURLImagenUsuarioID($id){
	return 'https://graph.facebook.com/'.$id.'/picture';
}

function ObtenerArrayAmigos($FacebookInstance){

	try{
		$amigos = $FacebookInstance->api('/me/friends');
	}
	catch (FacebookApiException $e) {

		echo "Se ha producido un error, puede que se cerrase la sesion. Por favor salga y vuelva a conectarse de nuevo.";
	}

	return $amigos;
}

function ObtenerFeed($id,$FacebookInstance, $numMensajes, $camposMensaje){

	if($id=="me"){
		$feed = $FacebookInstance->api('/me/feed?limit='.$numMensajes.'&fields='.$camposMensaje);
	}
	else{

		if($id!=null){

			$feed = $FacebookInstance->api('/'.$id.'/feed?limit='.$numMensajes.'&fields='.$camposMensaje);
		}
	}

	return $feed;

}


?>